| The Gaudi Framework v29r0 (ff2e7097)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Private Types | Private Member Functions | Private Attributes | Friends | List of all members
DataSvcHelpers::RegistryEntry Class Reference

Definition of an entry in the transient data store. More...

`#include <GaudiKernel/RegistryEntry.h>`

Inheritance diagram for DataSvcHelpers::RegistryEntry:
[legend]
Collaboration diagram for DataSvcHelpers::RegistryEntry:
[legend]

## Public Types
typedef Store::const_iterator | Iterator
| Iterator definition. More...
Public Types inherited from IRegistry
typedef std::string | name_type
| Type definitions Name type. More...
typedef std::string | id_type
| Identifier Key type. More...

## Public Member Functions
| RegistryEntry (std::string path, RegistryEntry *parent=nullptr)
| Standard Constructor. More...
| ~RegistryEntry () override
| Standard Destructor. More...
unsigned long | release () override
| IInterface implementation: Reference the object. More...
unsigned long | addRef () override
| IInterface implementation: Dereference the object. More...
const std::string & | name () const override
| Retrieve name of the entry. More...
const std::string & | identifier () const override
| Full identifier (or key) More...
IDataProviderSvc * | dataSvc () const override
| Retrieve pointer to Transient Store. More...
DataObject * | object () const override
| Retrive object behind the link. More...
IOpaqueAddress * | address () const override
| Retrieve opaque storage address. More...
virtual IRegistry * | parent () const
| Pointer to parent directory entry. More...
virtual bool | isSoft () const
| Is the link soft or hard. More...
const Store & | leaves () const
| Access the leaves of the object. More...
virtual int | size () const
| Return the size of the container(=number of objects) More...
virtual bool | isEmpty () const
| Simple check if the Container is empty. More...
virtual Iterator | begin () const
| Return starting point for container iteration. More...
virtual Iterator | end () const
| Return end elemtn if the container. More...
virtual IRegistry * | find (const IRegistry *obj) const
| Try to find an object identified by its pointer. More...
virtual IRegistry * | find (const std::string &path) const
| Try to find an object identified by its relative name to the directory. More...
void | setAddress (IOpaqueAddress *pAddress) override
| Set/Update Opaque address. More...
void | setObject (DataObject *obj)
| Set/Update object address. More...
virtual long | add (const std::string &name, DataObject *pObject, bool is_soft=false)
| Add entry to data store. More...
virtual long | add (const std::string &name, IOpaqueAddress *pAddress, bool is_soft=false)
| Add entry to data store. More...
virtual long | remove (const std::string &name)
| Remove an entry from the store. More...
virtual long | add (IRegistry *obj)
| Add object to the container. More...
virtual long | remove (IRegistry *obj)
| Remove an object from the container. More...
virtual long | deleteElements ()
| Delete all contained elements. More...
virtual long | traverseTree (IDataStoreAgent *pAgent, int level=0)
| traverse data tree More...
Public Member Functions inherited from IRegistry
virtual | ~IRegistry ()=default
| destructor More...

## Private Types
typedef std::vector< IRegistry * > | Store
| Definition of datastore type. More...

## Private Member Functions
void | assemblePath (std::string &buffer) const
| The following entries serve two aspects: 1) They are faster for recursive calls, because they are non-virtual 2) They can be re-used for the non-const entry points using a const_cast of the result. More...
IRegistry * | i_find (const IRegistry *pDirectory) const
| Internal method to retrieve data directory. More...
RegistryEntry * | i_find (boost::string_ref path) const
| Internal method to retrieve data directory. More...
RegistryEntry * | i_find (const DataObject *pObject) const
| Internal method to locate object entry. More...
RegistryEntry * | i_create (std::string name)
| Internal method to create entries. More...
long | i_add (RegistryEntry *entry)
| Internal method to add entries. More...
void | setParent (RegistryEntry *pParent)
| Set new parent pointer. More...
void | setDataSvc (IDataProviderSvc *s)
| Set the transient data store. More...
virtual RegistryEntry * | parentEntry ()
| Pointer to parent registry entry. More...
RegistryEntry * | findLeaf (boost::string_ref path) const
| Find identified leaf in this registry node. More...
RegistryEntry * | findLeaf (const DataObject *key) const
| Find identified leaf in this registry node. More...
void | makeHard (DataObject *pObject)
| Initialize link as hard link. More...
void | makeHard (IOpaqueAddress *pAddress)
| Initialize link as hard link. More...
void | makeSoft (DataObject *pObject)
| Initialize link as soft link. More...
void | makeSoft (IOpaqueAddress *pAddress)
| Initialize link as soft link. More...

## Private Attributes
unsigned long | m_refCount = 0
| Reference counter. More...
bool | m_isSoft = false
| Is the link soft or hard? More...
std::string | m_fullpath
| String containing full path of the object (volatile) More...
std::string | m_path
| Path name. More...
RegistryEntry * | m_pParent = nullptr
| Pointer to parent. More...
IOpaqueAddress * | m_pAddress = nullptr
| Pointer to opaque address (load info) More...
DataObject * | m_pObject = nullptr
| Pointer to object. More...
IDataProviderSvc * | m_pDataProviderSvc = nullptr
| Pointer to hosting transient store. More...
Store | m_store
| Store of leaves. More...

## Friends
class | ::DataSvc
class | ::TsDataSvc

## Detailed Description

Definition of an entry in the transient data store.

The RegistryEntry represents an entry of the transient data store. The object holds the recipe how to retrieve objects from the persistent world (member IOpaqueAddress) as well as the backward link to the parent entry and the leaves.

Author
  Markus Frank
  Sebastien Ponce

Definition at line 36 of file RegistryEntry.h.

## Member Typedef Documentation

typedef Store::const_iterator DataSvcHelpers::RegistryEntry::Iterator

Iterator definition.

Definition at line 47 of file RegistryEntry.h.

typedef std::vector<IRegistry*> DataSvcHelpers::RegistryEntry::Store
| private

Definition of datastore type.

Definition at line 40 of file RegistryEntry.h.

## Constructor & Destructor Documentation

DataSvcHelpers::RegistryEntry::RegistryEntry | ( | std::string | path,
|  | RegistryEntry * | parent = `nullptr`
| ) |  |

Standard Constructor.

Definition at line 43 of file RegistryEntry.cpp.

44 : m_path( std::move( path ) ), m_pParent( parent )
45 {
46 std::string::size_type sep = m_path.rfind( SEPARATOR );
47 if ( m_path.front() != SEPARATOR ) m_path.insert( 0, 1, SEPARATOR );
48 if ( sep != std::string::npos ) m_path.erase( 0, sep );
49 assemblePath( m_fullpath );
50 addRef();
51 }
SEPARATOR
constexpr char SEPARATOR
Definition: RegistryEntry.cpp:40
std::string::front
T front(T...args)
DataSvcHelpers::RegistryEntry::addRef
unsigned long addRef() override
IInterface implementation: Dereference the object.
Definition: RegistryEntry.h:114
std::string::rfind
T rfind(T...args)
DataSvcHelpers::RegistryEntry::m_pParent
RegistryEntry * m_pParent
Pointer to parent.
Definition: RegistryEntry.h:59
DataSvcHelpers::RegistryEntry::m_fullpath
std::string m_fullpath
String containing full path of the object (volatile)
Definition: RegistryEntry.h:55
DataSvcHelpers::RegistryEntry::assemblePath
void assemblePath(std::string &buffer) const
The following entries serve two aspects: 1) They are faster for recursive calls, because they are non...
Definition: RegistryEntry.cpp:318
std::string::erase
T erase(T...args)
std::move
T move(T...args)
std::string::insert
T insert(T...args)
DataSvcHelpers::RegistryEntry::parent
virtual IRegistry * parent() const
Pointer to parent directory entry.
Definition: RegistryEntry.h:126
DataSvcHelpers::RegistryEntry::m_path
std::string m_path
Path name.
Definition: RegistryEntry.h:57

DataSvcHelpers::RegistryEntry::~RegistryEntry | ( |  | ) |
| override

Standard Destructor.

Standard destructor.

Definition at line 54 of file RegistryEntry.cpp.

55 {
56 deleteElements();
57 if ( m_pObject ) {
58 if ( !m_isSoft ) m_pObject->setRegistry( nullptr );
59 m_pObject->release();
60 }
61 if ( m_pAddress ) {
62 if ( !m_isSoft ) m_pAddress->setRegistry( nullptr );
63 m_pAddress->release();
64 }
65 }
DataSvcHelpers::RegistryEntry::deleteElements
virtual long deleteElements()
Delete all contained elements.
Definition: RegistryEntry.cpp:227
DataObject::setRegistry
void setRegistry(IRegistry *pRegistry)
Set pointer to Registry.
Definition: DataObject.h:70
IOpaqueAddress::release
virtual unsigned long release()=0
release reference to object
DataSvcHelpers::RegistryEntry::m_pAddress
IOpaqueAddress * m_pAddress
Pointer to opaque address (load info)
Definition: RegistryEntry.h:61
DataSvcHelpers::RegistryEntry::m_isSoft
bool m_isSoft
Is the link soft or hard?
Definition: RegistryEntry.h:53
DataObject::release
virtual unsigned long release()
release reference to object
Definition: DataObject.cpp:51
DataSvcHelpers::RegistryEntry::m_pObject
DataObject * m_pObject
Pointer to object.
Definition: RegistryEntry.h:63
IOpaqueAddress::setRegistry
virtual void setRegistry(IRegistry *r)=0
Update directory pointer.

## Member Function Documentation

long DataSvcHelpers::RegistryEntry::add | ( | const std::string & | name,
|  | DataObject * | pObject,
|  | bool | is_soft = `false`
| ) |  |
| virtual

Add entry to data store.

Add entry to the current data store item.

Reimplemented in Hive::HiveEventRegistryEntry.

Definition at line 207 of file RegistryEntry.cpp.

208 {
209 RegistryEntry* entry = i_create( name );
210 if ( !entry ) return StatusCode::FAILURE;
211 ( is_soft ) ? entry->makeSoft( pObject ) : entry->makeHard( pObject );
212 i_add( entry );
213 return StatusCode::SUCCESS;
214 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
StatusCode::FAILURE
Definition: StatusCode.h:31
DataSvcHelpers::RegistryEntry::i_add
long i_add(RegistryEntry *entry)
Internal method to add entries.
Definition: RegistryEntry.cpp:185
DataSvcHelpers::RegistryEntry::i_create
RegistryEntry * i_create(std::string name)
Internal method to create entries.
Definition: RegistryEntry.cpp:168
DataSvcHelpers::RegistryEntry::RegistryEntry
RegistryEntry(std::string path, RegistryEntry *parent=nullptr)
Standard Constructor.
Definition: RegistryEntry.cpp:43

long DataSvcHelpers::RegistryEntry::add | ( | const std::string & | name,
|  | IOpaqueAddress * | pAddress,
|  | bool | is_soft = `false`
| ) |  |
| virtual

Add entry to data store.

Add entry to the current data store item.

Reimplemented in Hive::HiveEventRegistryEntry.

Definition at line 217 of file RegistryEntry.cpp.

218 {
219 RegistryEntry* entry = i_create( name );
220 if ( !entry ) return StatusCode::FAILURE;
221 ( is_soft ) ? entry->makeSoft( pAddress ) : entry->makeHard( pAddress );
222 i_add( entry );
223 return StatusCode::SUCCESS;
224 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
StatusCode::FAILURE
Definition: StatusCode.h:31
DataSvcHelpers::RegistryEntry::i_add
long i_add(RegistryEntry *entry)
Internal method to add entries.
Definition: RegistryEntry.cpp:185
DataSvcHelpers::RegistryEntry::i_create
RegistryEntry * i_create(std::string name)
Internal method to create entries.
Definition: RegistryEntry.cpp:168
DataSvcHelpers::RegistryEntry::RegistryEntry
RegistryEntry(std::string path, RegistryEntry *parent=nullptr)
Standard Constructor.
Definition: RegistryEntry.cpp:43

long DataSvcHelpers::RegistryEntry::add | ( | IRegistry * | obj | ) |
| virtual

Add object to the container.

Reimplemented in Hive::HiveEventRegistryEntry.

Definition at line 178 of file RegistryEntry.cpp.

179 {
180 RegistryEntry* pEntry = CAST_REGENTRY( RegistryEntry*, obj );
181 return i_add( pEntry );
182 }
CAST_REGENTRY
#define CAST_REGENTRY(x, y)
Definition: RegistryEntry.cpp:38
DataSvcHelpers::RegistryEntry::i_add
long i_add(RegistryEntry *entry)
Internal method to add entries.
Definition: RegistryEntry.cpp:185
DataSvcHelpers::RegistryEntry::RegistryEntry
RegistryEntry(std::string path, RegistryEntry *parent=nullptr)
Standard Constructor.
Definition: RegistryEntry.cpp:43

unsigned long DataSvcHelpers::RegistryEntry::addRef | ( |  | ) |
| inline override virtual

IInterface implementation: Dereference the object.

Implements IRegistry.

Definition at line 114 of file RegistryEntry.h.

114 { return ++m_refCount; }
DataSvcHelpers::RegistryEntry::m_refCount
unsigned long m_refCount
Reference counter.
Definition: RegistryEntry.h:51

IOpaqueAddress* DataSvcHelpers::RegistryEntry::address | ( |  | ) | const
| inline override virtual

Retrieve opaque storage address.

Implements IRegistry.

Definition at line 124 of file RegistryEntry.h.

124 { return m_pAddress; }
DataSvcHelpers::RegistryEntry::m_pAddress
IOpaqueAddress * m_pAddress
Pointer to opaque address (load info)
Definition: RegistryEntry.h:61

void DataSvcHelpers::RegistryEntry::assemblePath | ( | std::string & | buffer | ) | const
| private

The following entries serve two aspects: 1) They are faster for recursive calls, because they are non-virtual 2) They can be re-used for the non-const entry points using a const_cast of the result.

Recursive helper to assemble the full path name of the entry

Definition at line 318 of file RegistryEntry.cpp.

319 {
320 if ( m_pParent ) m_pParent->assemblePath( buffer );
321 buffer += m_path;
322 }
DataSvcHelpers::RegistryEntry::m_pParent
RegistryEntry * m_pParent
Pointer to parent.
Definition: RegistryEntry.h:59
DataSvcHelpers::RegistryEntry::assemblePath
void assemblePath(std::string &buffer) const
The following entries serve two aspects: 1) They are faster for recursive calls, because they are non...
Definition: RegistryEntry.cpp:318
DataSvcHelpers::RegistryEntry::m_path
std::string m_path
Path name.
Definition: RegistryEntry.h:57

virtual Iterator DataSvcHelpers::RegistryEntry::begin | ( |  | ) | const
| inline virtual

Return starting point for container iteration.

Definition at line 136 of file RegistryEntry.h.

136 { return m_store.begin(); }
std::vector::begin
T begin(T...args)
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67

IDataProviderSvc* DataSvcHelpers::RegistryEntry::dataSvc | ( |  | ) | const
| inline override virtual

Retrieve pointer to Transient Store.

Implements IRegistry.

Definition at line 120 of file RegistryEntry.h.

120 { return m_pDataProviderSvc; }
DataSvcHelpers::RegistryEntry::m_pDataProviderSvc
IDataProviderSvc * m_pDataProviderSvc
Pointer to hosting transient store.
Definition: RegistryEntry.h:65

long DataSvcHelpers::RegistryEntry::deleteElements | ( |  | ) |
| virtual

Delete all contained elements.

Delete recursively all elements pending from the current store item.

Definition at line 227 of file RegistryEntry.cpp.

228 {
229 for ( auto& i : m_store ) {
230 RegistryEntry* entry = CAST_REGENTRY( RegistryEntry*, i );
231 if ( entry ) {
232 entry->deleteElements();
233 entry->release();
234 }
235 }
236 m_store.erase( m_store.begin(), m_store.end() );
237 return 0;
238 }
CAST_REGENTRY
#define CAST_REGENTRY(x, y)
Definition: RegistryEntry.cpp:38
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67
DataSvcHelpers::RegistryEntry::RegistryEntry
RegistryEntry(std::string path, RegistryEntry *parent=nullptr)
Standard Constructor.
Definition: RegistryEntry.cpp:43

virtual Iterator DataSvcHelpers::RegistryEntry::end | ( |  | ) | const
| inline virtual

Return end elemtn if the container.

Definition at line 138 of file RegistryEntry.h.

138 { return m_store.end(); }
std::vector::end
T end(T...args)
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67

virtual IRegistry* DataSvcHelpers::RegistryEntry::find | ( | const IRegistry * | obj | ) | const
| inline virtual

Try to find an object identified by its pointer.

Definition at line 140 of file RegistryEntry.h.

140 { return i_find( obj ); }
DataSvcHelpers::RegistryEntry::i_find
IRegistry * i_find(const IRegistry *pDirectory) const
Internal method to retrieve data directory.
Definition: RegistryEntry.cpp:241

virtual IRegistry* DataSvcHelpers::RegistryEntry::find | ( | const std::string & | path | ) | const
| inline virtual

Try to find an object identified by its relative name to the directory.

Definition at line 142 of file RegistryEntry.h.

142 { return i_find( path ); }
DataSvcHelpers::RegistryEntry::i_find
IRegistry * i_find(const IRegistry *pDirectory) const
Internal method to retrieve data directory.
Definition: RegistryEntry.cpp:241

RegistryEntry* DataSvcHelpers::RegistryEntry::findLeaf | ( | boost::string_ref | path | ) | const
| inline private

Find identified leaf in this registry node.

Definition at line 94 of file RegistryEntry.h.

94 { return i_find( path ); }
GaudiPython.HistoUtils.path
path
Definition: HistoUtils.py:895
DataSvcHelpers::RegistryEntry::i_find
IRegistry * i_find(const IRegistry *pDirectory) const
Internal method to retrieve data directory.
Definition: RegistryEntry.cpp:241

RegistryEntry* DataSvcHelpers::RegistryEntry::findLeaf | ( | const DataObject * | key | ) | const
| inline private

Find identified leaf in this registry node.

Definition at line 96 of file RegistryEntry.h.

96 { return i_find( key ); }
DataSvcHelpers::RegistryEntry::i_find
IRegistry * i_find(const IRegistry *pDirectory) const
Internal method to retrieve data directory.
Definition: RegistryEntry.cpp:241

long DataSvcHelpers::RegistryEntry::i_add | ( | RegistryEntry * | entry | ) |
| private

Internal method to add entries.

Add object to the container.

Definition at line 185 of file RegistryEntry.cpp.

186 {
187 // TODO: if this is the sole place where items are added to m_store,
188 // and we know here that they must be RegisteryEntry, can we
189 // drop the dynamic_cast every where else???
190 // TODO: if so, can we also change m_store to be std::vector<RegistryEntry*>
191 // instead
192 // TODO: if so, can we not make it std::vector<RegistryEntry> instead?
193 // TODO: if so, should make sure that a RegistryEntry can be std::move'ed
194 try {
195 pEntry->setDataSvc( m_pDataProviderSvc );
196 m_store.push_back( pEntry );
197 pEntry->setParent( this );
198 if ( !pEntry->isSoft() && pEntry->address() ) {
199 pEntry->address()->setRegistry( pEntry );
200 }
201 } catch ( ... ) {
202 }
203 return m_store.size();
204 }
std::vector::push_back
T push_back(T...args)
DataSvcHelpers::RegistryEntry::m_pDataProviderSvc
IDataProviderSvc * m_pDataProviderSvc
Pointer to hosting transient store.
Definition: RegistryEntry.h:65
std::vector::size
T size(T...args)
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67
IOpaqueAddress::setRegistry
virtual void setRegistry(IRegistry *r)=0
Update directory pointer.
IRegistry::address
virtual IOpaqueAddress * address() const =0
Retrieve opaque storage address.

DataSvcHelpers::RegistryEntry * DataSvcHelpers::RegistryEntry::i_create | ( | std::string | name | ) |
| private

Internal method to create entries.

Internal method to add entries.

Definition at line 168 of file RegistryEntry.cpp.

169 {
170 if ( nam.front() != SEPARATOR ) nam.insert( 0, 1, SEPARATOR );
171 // if this object is already present, this is an error....
172 auto not_present =
173 std::none_of( std::begin( m_store ), std::end( m_store ), [&]( IRegistry* i ) { return nam == i->name(); } );
174 return not_present ? new RegistryEntry( std::move( nam ), this ) : nullptr;
175 }
SEPARATOR
constexpr char SEPARATOR
Definition: RegistryEntry.cpp:40
IRegistry::name
virtual const name_type & name() const =0
Name of the directory (or key)
std::end
T end(T...args)
IRegistry
The IRegistry represents the entry door to the environment any data object residing in a transient da...
Definition: IRegistry.h:22
std::move
T move(T...args)
std::begin
T begin(T...args)
std::none_of
T none_of(T...args)
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67
DataSvcHelpers::RegistryEntry::RegistryEntry
RegistryEntry(std::string path, RegistryEntry *parent=nullptr)
Standard Constructor.
Definition: RegistryEntry.cpp:43

IRegistry * DataSvcHelpers::RegistryEntry::i_find | ( | const IRegistry * | pDirectory | ) | const
| private

Internal method to retrieve data directory.

Try to find an object identified by its pointer.

Definition at line 241 of file RegistryEntry.cpp.

242 {
243 auto i = std::find( m_store.begin(), m_store.end(), obj );
244 return ( i != m_store.end() ) ? ( *i ) : nullptr;
245 }
std::vector::end
T end(T...args)
std::find
T find(T...args)
std::vector::begin
T begin(T...args)
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67

DataSvcHelpers::RegistryEntry * DataSvcHelpers::RegistryEntry::i_find | ( | boost::string_ref | path | ) | const
| private

Internal method to retrieve data directory.

Find identified leaf in this registry node.

Definition at line 248 of file RegistryEntry.cpp.

249 {
250 if ( path.front() == SEPARATOR ) path.remove_prefix( 1 ); // strip leading '/', if present
251 while ( !path.empty() ) {
252 // check that the chars of path prior to / are the same as regEnt->name()
253 // (i.e. match { nam:"/Ab" path:"/Ab/C"}
254 // but not { nam:"/Abc" path:"/Ab/C"})
255 auto loc1 = path.find( SEPARATOR );
256 auto cpath = path.substr( 0, loc1 );
257 if ( loc1 != boost::string_ref::npos ) {
258 path.remove_prefix( loc1 + 1 );
259 } else {
260 path.clear();
261 }
262 auto i = std::find_if( std::begin( m_store ), std::end( m_store ), [&]( decltype( m_store )::const_reference reg ) {
263 return cpath == boost::string_ref{reg->name()}.substr( 1 );
264 } );
265 if ( i != std::end( m_store ) ) {
266 RegistryEntry* regEnt = CAST_REGENTRY( RegistryEntry*, *i );
267 return path.empty() ? regEnt : regEnt->i_find( path );
268 }
269 // If this node is "/NodeA", this part allows to find "/NodeA/NodeB" as
270 // our "/NodeB" child.
271 if ( cpath != boost::string_ref{m_path}.substr( 1 ) ) break;
272 }
273 return nullptr;
274 }
GaudiPython.HistoUtils.path
path
Definition: HistoUtils.py:895
SEPARATOR
constexpr char SEPARATOR
Definition: RegistryEntry.cpp:40
CAST_REGENTRY
#define CAST_REGENTRY(x, y)
Definition: RegistryEntry.cpp:38
std::end
T end(T...args)
std::find_if
T find_if(T...args)
std::begin
T begin(T...args)
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67
DataSvcHelpers::RegistryEntry::RegistryEntry
RegistryEntry(std::string path, RegistryEntry *parent=nullptr)
Standard Constructor.
Definition: RegistryEntry.cpp:43
DataSvcHelpers::RegistryEntry::m_path
std::string m_path
Path name.
Definition: RegistryEntry.h:57
std::string::substr
T substr(T...args)

DataSvcHelpers::RegistryEntry * DataSvcHelpers::RegistryEntry::i_find | ( | const DataObject * | pObject | ) | const
| private

Internal method to locate object entry.

Find identified leaf in this registry node.

Definition at line 277 of file RegistryEntry.cpp.

278 {
279 if ( key ) {
280 if ( key == m_pObject ) {
281 return const_cast<RegistryEntry*>( this );
282 }
283 // Look in the immediate level:
284 RegistryEntry* result = CAST_REGENTRY( RegistryEntry*, i_find( key->registry() ) );
285 if ( result ) return result;
286 // Go levels down
287 for ( const auto& i : m_store ) {
288 try {
289 const RegistryEntry* entry = CAST_REGENTRY( RegistryEntry*, i );
290 result = entry->i_find( key );
291 if ( result ) return result;
292 } catch ( ... ) {
293 }
294 }
295 }
296 return nullptr;
297 }
CAST_REGENTRY
#define CAST_REGENTRY(x, y)
Definition: RegistryEntry.cpp:38
DataSvcHelpers::RegistryEntry::m_pObject
DataObject * m_pObject
Pointer to object.
Definition: RegistryEntry.h:63
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67
DataSvcHelpers::RegistryEntry::RegistryEntry
RegistryEntry(std::string path, RegistryEntry *parent=nullptr)
Standard Constructor.
Definition: RegistryEntry.cpp:43
DataSvcHelpers::RegistryEntry::i_find
IRegistry * i_find(const IRegistry *pDirectory) const
Internal method to retrieve data directory.
Definition: RegistryEntry.cpp:241

const std::string& DataSvcHelpers::RegistryEntry::identifier | ( |  | ) | const
| inline override virtual

Full identifier (or key)

Implements IRegistry.

Definition at line 118 of file RegistryEntry.h.

118 { return m_fullpath; }
DataSvcHelpers::RegistryEntry::m_fullpath
std::string m_fullpath
String containing full path of the object (volatile)
Definition: RegistryEntry.h:55

virtual bool DataSvcHelpers::RegistryEntry::isEmpty | ( |  | ) | const
| inline virtual

Simple check if the Container is empty.

Definition at line 134 of file RegistryEntry.h.

134 { return m_store.size() == 0; }
std::vector::size
T size(T...args)
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67

virtual bool DataSvcHelpers::RegistryEntry::isSoft | ( |  | ) | const
| inline virtual

Is the link soft or hard.

Definition at line 128 of file RegistryEntry.h.

128 { return m_isSoft; }
DataSvcHelpers::RegistryEntry::m_isSoft
bool m_isSoft
Is the link soft or hard?
Definition: RegistryEntry.h:53

const Store& DataSvcHelpers::RegistryEntry::leaves | ( |  | ) | const
| inline

Access the leaves of the object.

Definition at line 130 of file RegistryEntry.h.

130 { return m_store; }
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67

void DataSvcHelpers::RegistryEntry::makeHard | ( | DataObject * | pObject | ) |
| private

Initialize link as hard link.

Create hard link.

Definition at line 101 of file RegistryEntry.cpp.

102 {
103 makeSoft( pObject );
104 m_isSoft = false;
105 if ( m_pObject ) m_pObject->setRegistry( this );
106 if ( m_pAddress ) m_pAddress->setRegistry( this );
107 }
DataObject::setRegistry
void setRegistry(IRegistry *pRegistry)
Set pointer to Registry.
Definition: DataObject.h:70
DataSvcHelpers::RegistryEntry::m_pAddress
IOpaqueAddress * m_pAddress
Pointer to opaque address (load info)
Definition: RegistryEntry.h:61
DataSvcHelpers::RegistryEntry::makeSoft
void makeSoft(DataObject *pObject)
Initialize link as soft link.
Definition: RegistryEntry.cpp:84
DataSvcHelpers::RegistryEntry::m_isSoft
bool m_isSoft
Is the link soft or hard?
Definition: RegistryEntry.h:53
DataSvcHelpers::RegistryEntry::m_pObject
DataObject * m_pObject
Pointer to object.
Definition: RegistryEntry.h:63
IOpaqueAddress::setRegistry
virtual void setRegistry(IRegistry *r)=0
Update directory pointer.

void DataSvcHelpers::RegistryEntry::makeHard | ( | IOpaqueAddress * | pAddress | ) |
| private

Initialize link as hard link.

Create hard link.

Definition at line 110 of file RegistryEntry.cpp.

111 {
112 m_isSoft = false;
113 setAddress( pAddress );
114 }
DataSvcHelpers::RegistryEntry::setAddress
void setAddress(IOpaqueAddress *pAddress) override
Set/Update Opaque address.
Definition: RegistryEntry.cpp:117
DataSvcHelpers::RegistryEntry::m_isSoft
bool m_isSoft
Is the link soft or hard?
Definition: RegistryEntry.h:53

void DataSvcHelpers::RegistryEntry::makeSoft | ( | DataObject * | pObject | ) |
| private

Initialize link as soft link.

Create soft link.

Definition at line 84 of file RegistryEntry.cpp.

85 {
86 m_isSoft = true;
87 setObject( pObject );
88 // if ( 0 != m_pObject ) { // Useless: This justs sets my own address again...
89 // setAddress(m_pObject->address());
90 // }
91 }
DataSvcHelpers::RegistryEntry::setObject
void setObject(DataObject *obj)
Set/Update object address.
Definition: RegistryEntry.cpp:128
DataSvcHelpers::RegistryEntry::m_isSoft
bool m_isSoft
Is the link soft or hard?
Definition: RegistryEntry.h:53

void DataSvcHelpers::RegistryEntry::makeSoft | ( | IOpaqueAddress * | pAddress | ) |
| private

Initialize link as soft link.

Create soft link.

Definition at line 94 of file RegistryEntry.cpp.

95 {
96 m_isSoft = true;
97 setAddress( pAddress );
98 }
DataSvcHelpers::RegistryEntry::setAddress
void setAddress(IOpaqueAddress *pAddress) override
Set/Update Opaque address.
Definition: RegistryEntry.cpp:117
DataSvcHelpers::RegistryEntry::m_isSoft
bool m_isSoft
Is the link soft or hard?
Definition: RegistryEntry.h:53

const std::string& DataSvcHelpers::RegistryEntry::name | ( |  | ) | const
| inline override virtual

Retrieve name of the entry.

Implements IRegistry.

Definition at line 116 of file RegistryEntry.h.

116 { return m_path; }
DataSvcHelpers::RegistryEntry::m_path
std::string m_path
Path name.
Definition: RegistryEntry.h:57

DataObject* DataSvcHelpers::RegistryEntry::object | ( |  | ) | const
| inline override virtual

Retrive object behind the link.

Implements IRegistry.

Definition at line 122 of file RegistryEntry.h.

122 { return m_pObject; }
DataSvcHelpers::RegistryEntry::m_pObject
DataObject * m_pObject
Pointer to object.
Definition: RegistryEntry.h:63

virtual IRegistry* DataSvcHelpers::RegistryEntry::parent | ( |  | ) | const
| inline virtual

Pointer to parent directory entry.

Definition at line 126 of file RegistryEntry.h.

126 { return m_pParent; }
DataSvcHelpers::RegistryEntry::m_pParent
RegistryEntry * m_pParent
Pointer to parent.
Definition: RegistryEntry.h:59

virtual RegistryEntry* DataSvcHelpers::RegistryEntry::parentEntry | ( |  | ) |
| inline private virtual

Pointer to parent registry entry.

Definition at line 92 of file RegistryEntry.h.

92 { return m_pParent; }
DataSvcHelpers::RegistryEntry::m_pParent
RegistryEntry * m_pParent
Pointer to parent.
Definition: RegistryEntry.h:59

unsigned long DataSvcHelpers::RegistryEntry::release | ( |  | ) |
| override virtual

IInterface implementation: Reference the object.

Release entry.

Implements IRegistry.

Definition at line 68 of file RegistryEntry.cpp.

69 {
70 unsigned long cnt = --m_refCount;
71 if ( !m_refCount ) delete this;
72 return cnt;
73 }
DataSvcHelpers::RegistryEntry::m_refCount
unsigned long m_refCount
Reference counter.
Definition: RegistryEntry.h:51

long DataSvcHelpers::RegistryEntry::remove | ( | const std::string & | name | ) |
| virtual

Remove an entry from the store.

Remove entry from data store.

Definition at line 154 of file RegistryEntry.cpp.

155 {
156 if ( nam.front() != SEPARATOR ) return remove( SEPARATOR + nam );
157 // if this object is already present, this is an error....
158 for ( auto& i : m_store ) {
159 if ( nam == i->name() ) {
160 remove( i );
161 return StatusCode::SUCCESS;
162 }
163 }
164 return StatusCode::FAILURE;
165 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
SEPARATOR
constexpr char SEPARATOR
Definition: RegistryEntry.cpp:40
StatusCode::FAILURE
Definition: StatusCode.h:31
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67

long DataSvcHelpers::RegistryEntry::remove | ( | IRegistry * | obj | ) |
| virtual

Remove an object from the container.

Definition at line 139 of file RegistryEntry.cpp.

140 {
141 try {
142 RegistryEntry* pEntry = dynamic_cast<RegistryEntry*>( obj );
143 auto i = std::remove( std::begin( m_store ), std::end( m_store ), pEntry );
144 if ( i != std::end( m_store ) ) {
145 pEntry->release();
146 m_store.erase( i, std::end( m_store ) );
147 }
148 } catch ( ... ) {
149 }
150 return m_store.size();
151 }
std::end
T end(T...args)
std::remove
T remove(T...args)
std::vector::erase
T erase(T...args)
std::vector::size
T size(T...args)
std::begin
T begin(T...args)
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67
DataSvcHelpers::RegistryEntry::RegistryEntry
RegistryEntry(std::string path, RegistryEntry *parent=nullptr)
Standard Constructor.
Definition: RegistryEntry.cpp:43

void DataSvcHelpers::RegistryEntry::setAddress | ( | IOpaqueAddress * | pAddress | ) |
| override virtual

Set/Update Opaque address.

Update Opaque address of registry entry.

Implements IRegistry.

Definition at line 117 of file RegistryEntry.cpp.

118 {
119 if ( pAddress ) {
120 pAddress->addRef();
121 pAddress->setRegistry( this );
122 }
123 if ( m_pAddress ) m_pAddress->release();
124 m_pAddress = pAddress;
125 }
IOpaqueAddress::release
virtual unsigned long release()=0
release reference to object
DataSvcHelpers::RegistryEntry::m_pAddress
IOpaqueAddress * m_pAddress
Pointer to opaque address (load info)
Definition: RegistryEntry.h:61
IOpaqueAddress::setRegistry
virtual void setRegistry(IRegistry *r)=0
Update directory pointer.
IOpaqueAddress::addRef
virtual unsigned long addRef()=0
Add reference to object.

void DataSvcHelpers::RegistryEntry::setDataSvc | ( | IDataProviderSvc * | s | ) |
| inline private

Set the transient data store.

Definition at line 90 of file RegistryEntry.h.

90 { m_pDataProviderSvc = s; }
DataSvcHelpers::RegistryEntry::m_pDataProviderSvc
IDataProviderSvc * m_pDataProviderSvc
Pointer to hosting transient store.
Definition: RegistryEntry.h:65
gaudirun.s
string s
Definition: gaudirun.py:253

void DataSvcHelpers::RegistryEntry::setObject | ( | DataObject * | obj | ) |

Set/Update object address.

Set object pointer of data store item.

Definition at line 128 of file RegistryEntry.cpp.

129 {
130 if ( pObject ) {
131 pObject->addRef();
132 if ( !isSoft() ) pObject->setRegistry( this );
133 }
134 if ( m_pObject ) m_pObject->release();
135 m_pObject = pObject;
136 }
DataSvcHelpers::RegistryEntry::isSoft
virtual bool isSoft() const
Is the link soft or hard.
Definition: RegistryEntry.h:128
DataObject::release
virtual unsigned long release()
release reference to object
Definition: DataObject.cpp:51
DataSvcHelpers::RegistryEntry::m_pObject
DataObject * m_pObject
Pointer to object.
Definition: RegistryEntry.h:63

void DataSvcHelpers::RegistryEntry::setParent | ( | RegistryEntry * | pParent | ) |
| private

Set new parent pointer.

Definition at line 76 of file RegistryEntry.cpp.

77 {
78 m_pParent = pParent;
79 m_fullpath.clear();
80 assemblePath( m_fullpath );
81 }
DataSvcHelpers::RegistryEntry::m_pParent
RegistryEntry * m_pParent
Pointer to parent.
Definition: RegistryEntry.h:59
DataSvcHelpers::RegistryEntry::m_fullpath
std::string m_fullpath
String containing full path of the object (volatile)
Definition: RegistryEntry.h:55
DataSvcHelpers::RegistryEntry::assemblePath
void assemblePath(std::string &buffer) const
The following entries serve two aspects: 1) They are faster for recursive calls, because they are non...
Definition: RegistryEntry.cpp:318
std::string::clear
T clear(T...args)

virtual int DataSvcHelpers::RegistryEntry::size | ( |  | ) | const
| inline virtual

Return the size of the container(=number of objects)

Definition at line 132 of file RegistryEntry.h.

132 { return m_store.size(); }
std::vector::size
T size(T...args)
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67

long DataSvcHelpers::RegistryEntry::traverseTree | ( | IDataStoreAgent * | pAgent,
|  | int | level = `0`
| ) |  |
| virtual

traverse data tree

Definition at line 300 of file RegistryEntry.cpp.

301 {
302 bool go_down = pAgent->analyse( this, level );
303 long status = StatusCode::SUCCESS;
304 if ( go_down ) {
305 for ( auto& i : m_store ) {
306 try {
307 RegistryEntry* entry = CAST_REGENTRY( RegistryEntry*, i );
308 entry->traverseTree( pAgent, level + 1 );
309 } catch ( ... ) {
310 status = StatusCode::FAILURE;
311 }
312 }
313 }
314 return status;
315 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
StatusCode::FAILURE
Definition: StatusCode.h:31
IDataStoreAgent::analyse
virtual bool analyse(IRegistry *pObject, int level)=0
Analyse the data object.
CAST_REGENTRY
#define CAST_REGENTRY(x, y)
Definition: RegistryEntry.cpp:38
DataSvcHelpers::RegistryEntry::m_store
Store m_store
Store of leaves.
Definition: RegistryEntry.h:67
DataSvcHelpers::RegistryEntry::RegistryEntry
RegistryEntry(std::string path, RegistryEntry *parent=nullptr)
Standard Constructor.
Definition: RegistryEntry.cpp:43
gaudirun.level
level
Definition: gaudirun.py:271

## Friends And Related Function Documentation

friend class ::DataSvc
| friend

Definition at line 43 of file RegistryEntry.h.

friend class ::TsDataSvc
| friend

Definition at line 45 of file RegistryEntry.h.

## Member Data Documentation

std::string DataSvcHelpers::RegistryEntry::m_fullpath
| private

String containing full path of the object (volatile)

Definition at line 55 of file RegistryEntry.h.

bool DataSvcHelpers::RegistryEntry::m_isSoft = false
| private

Is the link soft or hard?

Definition at line 53 of file RegistryEntry.h.

IOpaqueAddress* DataSvcHelpers::RegistryEntry::m_pAddress = nullptr
| private

Pointer to opaque address (load info)

Definition at line 61 of file RegistryEntry.h.

std::string DataSvcHelpers::RegistryEntry::m_path
| private

Path name.

Definition at line 57 of file RegistryEntry.h.

IDataProviderSvc* DataSvcHelpers::RegistryEntry::m_pDataProviderSvc = nullptr
| private

Pointer to hosting transient store.

Definition at line 65 of file RegistryEntry.h.

DataObject* DataSvcHelpers::RegistryEntry::m_pObject = nullptr
| private

Pointer to object.

Definition at line 63 of file RegistryEntry.h.

RegistryEntry* DataSvcHelpers::RegistryEntry::m_pParent = nullptr
| private

Pointer to parent.

Definition at line 59 of file RegistryEntry.h.

unsigned long DataSvcHelpers::RegistryEntry::m_refCount = 0
| private

Reference counter.

Definition at line 51 of file RegistryEntry.h.

Store DataSvcHelpers::RegistryEntry::m_store
| private

Store of leaves.

Definition at line 67 of file RegistryEntry.h.

The documentation for this class was generated from the following files:

- GaudiKernel/GaudiKernel/RegistryEntry.h
- GaudiKernel/src/Lib/RegistryEntry.cpp